



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>在 C# 中，(int) ，Int32.Parse() 和 Convert.toInt32() 三种方法的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">在 C# 中，(int) ，Int32.Parse() 和 Convert.toInt32() 三种方法的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 23:36:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在 C# 中，(int)，Int32.Parse() 和 Convert.toInt32() 三种方法有何区别?</p>
<p>int 关键字表示一种整型，是32位的，它的 .NET Framework 类型为 System.Int32。</p>
<p>(int)表示使用显式强制转换，是一种类型转换。当我们从 int 类型到 long、float、double 或decimal 类型，可以使用隐式转换，但是当我们从 long 类型到 int&nbsp; 类型转换就需要使用显式强制转换，否则会产生编译错误。</p>
<p>Int32.Parse()表示将数字的字符串转换为32 位有符号整数，属于内容转换[1]。<br />&nbsp;&nbsp;&nbsp; 我们一种常见的方法：public static int Parse(string)。<br />&nbsp;&nbsp;&nbsp; 如果 string 为空，则抛出 ArgumentNullException 异常；<br />&nbsp;&nbsp;&nbsp; 如果 string 格式不正确，则抛出 FormatException 异常；<br />&nbsp;&nbsp;&nbsp; 如果 string 的值小于 MinValue 或大于 MaxValue 的数字，则抛出 OverflowException 异常。</p>
<p>Convert.ToInt32() 则可以将多种类型(包括 object&nbsp; 引用类型)的值转换为 int&nbsp; 类型,因为它有许多重载版本[2]：<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(object);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(bool);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(byte);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(char);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(decimal);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(double);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(short);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(long);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(sbyte);<br />&nbsp;&nbsp;&nbsp; public static int ToInt32(string);<br />&nbsp;&nbsp;&nbsp; ......</p>
<p><strong>(int)和Int32.Parse(),Convert.ToInt32()三者的应用举几个例子：</strong></p>
<p>例子一：</p>
<p>long longType = 100;<br />&nbsp;&nbsp;&nbsp; int intType&nbsp; = longType;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; // 错误，需要使用显式强制转换<br />&nbsp;&nbsp;&nbsp; int intType = (int)longType; //正确，使用了显式强制转换</p>
<p>例子二：</p>
<p>string stringType = "12345";&nbsp;<br />&nbsp;&nbsp;&nbsp; int intType = (int)stringType;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//错误，string 类型不能直接转换为 int&nbsp; 类型&nbsp;<br />&nbsp;&nbsp;&nbsp; int intType = Int32.Parse(stringType);&nbsp;&nbsp; //正确</p>
<p>例子三：</p>
<p>long longType = 100;<br />&nbsp;&nbsp;&nbsp; string stringType = "12345";<br />&nbsp;&nbsp;&nbsp; object objectType = "54321";<br />&nbsp;&nbsp;&nbsp; int intType = Convert.ToInt32(longType);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//正确<br />&nbsp;&nbsp;&nbsp; int intType = Convert.ToInt32(stringType);&nbsp;&nbsp;&nbsp;&nbsp; //正确<br />&nbsp;&nbsp;&nbsp; int intType = Convert.ToInt32(objectType);&nbsp;&nbsp;&nbsp; //正确</p>
<p>例子四[1]：</p>
<p>double doubleType = Int32.MaxValue + 1.011;&nbsp;<br />&nbsp;&nbsp;&nbsp; int intType = (int)doubleType;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //虽然运行正确，但是得出错误结果<br />&nbsp;&nbsp;&nbsp; int intType = Convert.ToInt32(doubleType)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //抛出 OverflowException 异常</p>
<p><strong>(int)和Int32.Parse(),Convert.ToInt32()三者的区别：</strong></p>
<p>第一个在对long 类型或是浮点型到int 类型的显式强制转换中使用，但是如果被转换的数值大于 Int32.MaxValue 或小于 Int32.MinValue，那么则会得到一个错误的结果。</p>
<p>第二个在符合数字格式的 string 到 int&nbsp; 类型转换过程中使用，并可以对错误的 string 数字格式的抛出相应的异常。</p>
<p>第三个则可以将多种类型的值转换为 int 类型，也可以对错误的数值抛出相应的异常。</p>
<p>无论进行什么类型的数值转换，数值的精度问题都是我们必须考虑的[1]。</p>
<p><strong>本文引用：<br /></strong><br />&nbsp;&nbsp;&nbsp; [1]&nbsp;<a href="http://zhidao.baidu.com/question/5393280.html" rel="external nofollow noreferrer">http://zhidao.baidu.com/question/5393280.html</a></p>
<p>[2] CSDN</p>
<p>原文：http://blog.csdn.net/scucj/article/details/846344</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2j6387.html">关于Vue&period;js 2&period;0 的 Vuex 2&period;0，你需要更新的知识库</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq14rg0q.html">ORACLE插入DATE类型字段</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96dwgv8.html">Postgresql死锁处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mrj229.html">Linux命令之diff</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jxrzwq.html">网页缩放对 FLASH的影响</a>
		</li>
						<li><a href="https://www.batexi.com/a/390on4m9.html">MyISAM InnoDB 区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrm508.html">access链接最原始代码，两种</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmpkw09.html">ruby cookbook</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj4y4y9.html">Linux GRUB 2及修改默认启动项</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgz2348.html">jsp生命周期和工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzn7gw8.html">MapReduce深度分析&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gero208.html">head first python菜鸟学习笔记（第三章）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo743dq.html">--save-dev 和 --save的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5lm19.html">Postman-----设置环境变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk7zgz8.html">python将多个pdf合成一个</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyrorx9.html">从 date 中取出 小时和分钟进行比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r6p0j9.html">Python twilio发短信实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn4v4eq.html">Python爬虫实例（六）多进程下载金庸网小说</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emwvpz9.html">【数组】Missing Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj3yg7q.html">页面返回刷新或H5监听&lpar;手机的&rpar;返回键</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e45jrk9.html">微信小程序遇到的知识点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1nlz49.html">Web API中的内容协商</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7olj6k8.html">微信小程序ext&lowbar;json示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1vweeq.html">springboot09-redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4561e9.html">深度理解PHP中for与foreach两个循环结构遍历数组的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25m16oq.html">基于TensorFlow Object Detection API进行相关开发的步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwkok78.html">url编码解码的问题（urlencode&sol;quote）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwd4lv9.html">python 小数据池&comma;is and &amp;quot&semi;&equals;&equals;&amp;quot&semi;&comma;decode &comma;encode</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1n46w9.html">Ant使用指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1v625q.html">Python 爬虫四 基础案例-自动登陆github</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
